var CookieConsent = Class.create({
  initialize : function(settings) {
    this.settings = settings;
    //this.clearCookie('cookieConsent'); // for debugging
    if(!this.getCookie('cookieConsent')){
      this.showDisclaimer();
    }
    $('ResetCookies').observe('click', function() {
      this.showDisclaimer();
    }.bind(this));
  },

  getCookie : function(key)
  {
    var keyEquals = key + "=";
    var value     = false;

    document.cookie.split(';').invoke('strip').each(function(s){
      if (s.startsWith(keyEquals)) {
        value = unescape(s.substring(keyEquals.length, s.length));
      }
    });

    return value;
  },

  setCookie : function(key, value, days) {
    var setValue      = key + '=' + escape(new String(value));
    var setExpiration = "";

    if (days) {
      var date = new Date();
      date.setTime(date.getTime() + (days*24*60*60*1000));
      var setExpiration = "; expires=" + date.toGMTString();
    }

    var cookieString = setValue + setExpiration + ";path=/";
    document.cookie  = cookieString;
  },

  clearCookie : function(key) {
    this.setCookie(key,'',-1);
  },

  animation : function(event, element) {
    switch(this.settings.animation)
    {
      case 'none': 
        event == 'show' ? $(element).show() : $(element).hide(); break;
      case 'slide': 
        event == 'show' ? Effect.BlindDown(element, { duration : 1 }) : Effect.BlindUp(element, { duration : 1 }); break;
      case 'fade':
        event == 'show' ? Effect.Appear(element, { duration : 1 }) : Effect.Fade(element, { duration : 1 }); break;
    }
  },

  showDisclaimer : function() {
    var htmlContent1 = this.settings.disclaimer1
                     + '<a href="#" class="button" role="button" name="cookieConsentHide" id="cookieConsentHide">'
                     + this.settings.buttonText
                     + '</a>'
                     + '<a href="#" class="button" role="button" name="cookieConsentConfig" id="cookieConsentConfig">'
                     + this.settings.configButtonText
                     + '</a>';
    
    var htmlContent2 = this.settings.disclaimer2
                     + '<div id="CookieSelectPane">'
                     + '<div class="CookieSelectButtonWrapper" title="' + this.settings.necessaryInfoBox + '">'
                     + '<label for="CookieButtonNecessary">'
                     + '<input id="CookieButtonNecessary" class="CookieButton" disabled="disabled" checked="checked" type="checkbox">'
                     + this.settings.mandatoryLabel + '</label>'
                     + '</div>'
                     + '<div class="CookieSelectButtonWrapper" title="' + this.settings.preferencesInfoBox + '">'
                     + '<label for="CookieButtonPreferences">'
                     + '<input id="CookieButtonPreferences" class="CookieButton" checked="checked" tabindex="1" type="checkbox">'
                     + this.settings.preferencesLabel + '</label>'
                     + '</div>'
                     + '<div class="CookieSelectButtonWrapper" title="' + this.settings.statisticsInfoBox + '">'
                     + '<label for="CookieButtonStatistics">'
                     + '<input id="CookieButtonStatistics" class="CookieButton" checked="checked" tabindex="1" type="checkbox">'
                     + this.settings.statisticsLabel + '</label>'
                     + '</div>'
                     + '<div class="CookieSelectButtonWrapper" title="' + this.settings.marketingInfoBox + '">'
                     + '<label for="CookieButtonMarketing">'
                     + '<input id="CookieButtonMarketing" class="CookieButton" tabindex="1" type="checkbox">'
                     + this.settings.marketingLabel + '</label>'
                     + '</div></div>'
                     + '<a href="#" class="button" role="button" name="cookieConsentOK" id="cookieConsentOK">OK</a>';

    var html = '<div id="cookieConsent" style="display: none;">'
             + '<div class="col-md-2"></div>'
             + '<div id="cookieConsentContent" class="col-md-8">' 
             + htmlContent1
             + '</div>'
             + '<div class="col-md-2"></div>'
             + '</div>'
             + '</div>';

    var gdprSettings = ['necessary', 'preferences','statistics','marketing'];
    $('xwikimaincontainerinner').insert( {before : html } );
    $("cookieConsentHide").observe('click', this.hideDisclaimer.bind(this, gdprSettings));
    $("cookieConsentConfig").addEventListener("click", function(){
      $("cookieConsentContent").innerHTML = htmlContent2;
      $("cookieConsentOK").observe('click', function() {
        if(!$("CookieButtonPreferences").checked){
          var index = gdprSettings.indexOf('preferences');
          if (index > -1) {
            gdprSettings.splice(index, 1);
          }
        }
        if(!$("CookieButtonStatistics").checked){
          var index = gdprSettings.indexOf('statistics');
          if (index > -1) {
            gdprSettings.splice(index, 1);
          }
        }
        if(!$("CookieButtonMarketing").checked){
          var index = gdprSettings.indexOf('marketing');
          if (index > -1) {
            gdprSettings.splice(index, 1);
          }
        }

        this.hideDisclaimer(gdprSettings);

      }.bind(this));
    }.bind(this));

    this.animation('show', 'cookieConsent');
  },

  hideDisclaimer : function(param) {
    this.setCookie('cookieConsent', 'hide', 365);
    this.setCookie('gdprSettings', param, 365);
    this.animation('hide', 'cookieConsent');
  }
});
                                
document.observe("dom:loaded", function() {
  var settings =
  {
    'type'       : "bar",
    'position'   : "bottom",
    'animation'  : "slide",
    'buttonType' : "$settings.getProperty('buttonType').value",
    'buttonText' : "I accept all Cookies",
    'configButtonText' : "Configure",
    'disclaimer1' : "<p>Salutations! This wiki server and other <strong>Titled, \"Untitled\"<\/strong> microservices may or may not use cookies, or may or may not be totally exempt from GPDR - idk! I don\'t plan to, but one ought to keep one\'s ass undercover, and all that. We may well enable Google Analytics, to turn your traffic into some colorful chart, which would very likely expose all your meanderings here to the optimization of their advertising service. Would you say that this statement, is \u201Cconcise, transparent, accessible, and written in clear and plain language\"? If not, i hereby reproduce the phrase, for you to pretend to have read and said:<\/p><p>This site uses cookies to improve your browsing experience, to perform analytics and for advertising. By clicking <strong>I accept all Cookies<\/strong> you agree to the use of cookies on your device. If you\'d like to change your preferences please visit the <span class=\"wikilink\"><a href=\"https:\/\/titleduntitled.name:80\/bin\/view\/CookieConsent\/CookiePolicy\">Cookie Policy<\/a><\/span> page.<\/p><p>\"Anyway, this story is quite tedious. It\'s a good thing it\'s finished. Whether you like it or not, I couldn\'t care less.\" (RAYMOND QUENEAU, Destiny)<\/p>",
    'disclaimer2' : "<p>Salutations! This wiki server and other <strong>Titled, \"Untitled\"<\/strong> microservices may or may not use cookies, or may or may not be totally exempt from GPDR - idk! I don\'t plan to, but one ought to keep one\'s ass undercover, and all that. We may well enable Google Analytics, to turn your traffic into some colorful chart, which would very likely expose all your meanderings here to the optimization of their advertising service. Would you say that this statement, is \u201Cconcise, transparent, accessible, and written in clear and plain language\"? If not, i hereby reproduce the phrase, for you to pretend to have read and said: This site uses cookies to improve your browsing experience, to perform analytics and for advertising. By clicking <strong>I accept all Cookies<\/strong> you agree to the use of cookies on your device. If you\'d like to change your preferences please visit the <span class=\"wikilink\"><a style=\"box-sizing: border-box; background-color: transparent; color: rgb(47, 164, 231); text-decoration: underline;\" href=\"https:\/\/titleduntitled.name:80\/bin\/view\/CookieConsent\/CookiePolicy\">Cookie Policy<\/a><\/span> page.<\/p><p>\"Anyway, this story is quite tedious. It\'s a good thing it\'s finished. Whether you like it or not, I couldn\'t care less.\" (RAYMOND QUENEAU, Destiny)<\/p>",
    'necessaryInfoBox' : "Necessary cookies which are mandatory and cannot be disabled",
    'preferencesInfoBox' : "Preferences cookies or trackers which are optional and enabled by default but used only to remember your preferences.",
    'statisticsInfoBox' : "Statistics related cookies or trackers which are optional and enabled by default and user to record anonymous statistics",
    'marketingInfoBox' : "Marketing or other related cookies or trackers which are optional and disabled by default and can record personal information",
    'mandatoryLabel' : "Necessary",
    'preferencesLabel' : "Preferences",
    'statisticsLabel' : "Statistics",
    'marketingLabel' : "Marketing"
    
  };  
  var cookieConsent = new CookieConsent(settings);
});

